<?php 
// Welcome to 乐众系统&IDC财务管理系统
// Copyright (c)  http://www.lzsys.com/ All rights reserved.
// Business authorization email server@lzsys.com
// 欢迎使用乐众系统&IDC财务管理系统


// [应用配置文件]
return $plugins_config = array(
    'name'     => '手机三要素认证',                      // 应用名称
	

    'type'     => '实名认证',                                // 类型 参考 https://www.lzsys.com/news/118.html

    'describe' => '对接腾讯云，云市场的实名认证接口，采用运营商手机认证 姓名+身份证+实名手机+验证码方式', // 应用描述

    'author'   => '乐众-MC',                          // 作者

    'qq'       => '1525265',                           // 作者QQ

    'url'      => 'http://www.lzsys.com',                  // 作者官网

    'shop'     => 'http://www.lzsys.com/buy.html', // 作者应用商店
	
    'plugin_version'  =>'1.0.1',                          // 版本信息
	
	'icon'     =>'auth.png',                             // 应用图标
	
	'install'  =>'install.php',                           // 应用安装文件  如 创建SQL表，创建目录等初始化功能
	
	'uninstall'=>'uninstall.php',                         // 应用卸载文件  如 删除表 删除目录等卸载功能
	
	'explain'  =>'http://www.lzsys.com/idc_file/help_auth_three.html',                  // 应用介绍，使用说明地址
	
	'panel'    =>true,                                    // 管理员独立管理面板 直接在本系统内管理 如渠道管理
	'panel_bottom'   =>"认证管理",                              // 在线管理面板（管理员端）
	'panel_open'    =>false,                                  // 是否在新窗口打开管理面板  false为原窗口 弹窗打开  true=新窗口	
	


    //----------------------------api = 添加接口时所填参数
	
	'create_api'     => array(
        array(
            'type' => 'input',                      // 输入类型  input 文本框   select 组合框  pass=密码框   number 数字框  radio=单选框
            'text' => '渠道名称',                    // 参数名称
            'placeholder' => '如：三要素实名',   // 输入说明
            'name' => 'name',                   // 参数名称    所有插件都必须有 name 参数
			'defaultvalue' => '',                   // 默认值 
            'rules' => array(                       // 是否必填 
                'required' => true,                 // true=必填  false=可空
                'message' => '请输入渠道名称',       // 必填若没有输入，则提示这段文字
                'trigger' => 'blur',                // 固定值
            ),

        ),

		array(
            'type' => 'input', 
            'text' => 'SecretID', 
            'placeholder' => '腾讯云市场中查看SecretID', 
            'name' => 'account',
			'defaultvalue' => '', 
            'rules' => array(     
                'required' => true,  
                'message' => '请输入SecretID', 
                'trigger' => 'blur', 
            ),

        ),
		array(
            'type' => 'input', 
            'text' => 'SecretKey', 
            'placeholder' => '腾讯云市场中查看SecretKey', 
            'name' => 'secret',
			'defaultvalue' => '', 
            'rules' => array(     
                'required' => true,  
                'message' => '请输入SecretKey', 
                'trigger' => 'blur', 
            ),

        ),
		array(
            'type' => 'input', 
            'text' => '认证费用', 
            'placeholder' => '客户实名认证需要花费多少钱', 
            'name' => 'money',
			'defaultvalue' => '', 
            'rules' => array(     
                'required' => true,  
                'message' => '请输入认证费用', 
                'trigger' => 'blur', 
            ),

        ),
	),
	// 添加API参数结束
	
	
    //----------------------------api = 添加实名身份信息
	
	'auth_api'     => array(
        array(
            'type' => 'input',                      // 输入类型  input 文本框   
            'text' => '姓名',                    // 参数名称
            'placeholder' => '如：张三',   // 输入说明
            'name' => 'name',                   // 参数名称    所有插件都必须有 name 参数
			'defaultvalue' => '',                   // 默认值 
			'str_start' => 3,  // 替换开始位置  中文每个汉字占用两个位置，3表示从第二个文字开始替换
			'str_stop' => 3,   // 替换结束位置  
			'pass' => '**', // 用于替代姓名的字符串 实名认证成功后，客户查看实名信息时，姓名会被此字符串替代
            'rules' => array(                       // 是否必填 
                'required' => true,                 // true=必填  false=可空
                'message' => '请输入姓名',       // 必填若没有输入，则提示这段文字
                'trigger' => 'blur',                // 固定值
            ),

        ),

		array(
            'type' => 'input', 
            'text' => '身份证', 
            'placeholder' => '请输入身份证号码', 
            'name' => 'card_num',
			'defaultvalue' => '',
			'str_start' => 3,  // 替换开始位置
			'str_stop' => 12,   // 替换结束位置
			'pass' => '************', // 用于替代身份证号码的字符串 实名认证成功后，客户查看实名信息时，身份证号码会被此字符串替代
            'rules' => array(     
                'required' => true,  
                'message' => '请输入身份证', 
                'trigger' => 'blur', 
            ),

        ),
		array(
            'type' => 'input', 
            'text' => '手机号', 
            'placeholder' => '请输入使用身份证实名办理的手机号', 
            'name' => 'tel',
			'defaultvalue' => '', 
			'str_start' => 3,  // 替换开始位置
			'str_stop' => 6,   // 替换结束位置
			'pass' => '******', // 用于替代手机号的字符串 实名认证成功后，客户查看实名信息时，手机号会被此字符串替代
            'rules' => array(     
                'required' => true,  
                'message' => '请输入手机号', 
                'trigger' => 'blur', 
            ),

        ),
		array(
            'type' => 'input', 
            'text' => '验证码', 
            'placeholder' => '请输入手机验证码', 
            'name' => 'vcode',  // vcode = 手机验证码   ecode=邮件验证码 imgcode
			'defaultvalue' => '', 
            'rules' => array(     
                'required' => true,  
                'message' => '请输入手机验证码', 
                'trigger' => 'blur', 
            ),

        ),

	),
	// 添加身份信息参数结束

	// 配置文件结束	
	
    );
