<?php 
// Welcome to 乐众系统&IDC财务管理系统
// Copyright (c)  http://www.lzsys.com/ All rights reserved.
// Business authorization email server@lzsys.com
// 欢迎使用乐众系统&IDC财务管理系统

// [实名应用 功能模块]

$api_config = $plugin->api_config();
$addons_config = $plugin->addons_config();
$asset_data = $plugin->asset_data();
$post = $plugin->ide->php->post();
$get = $plugin->ide->php->get();
$app_data = $plugin->ide->lzsys_system->app_data();
$hash = $app_data['app_hash']; //获取加密混合值

$addon_path = $addons_config['path'];// 获得 应用目录名称

//   -----------上面是固定数据，不懂不要修改

// 该应用在安装时 需要创建一张表  lzsys_three_auth_user_authlog 用于储存客户实名记录信息

//   表的格式必须为 lzsys_应用目录名称_user_authlog  如 应用目录名称是 aliyun 则表名 lzsys_aliyun_user_authlog

// 但是你执行表操作的时候 不需要输入 lzsys_ 表前缀有系统自动判断 

//  如查询表 $plugin->ide->mysql->get_db("user_id='1' and app_id='10016'","three_auth_user_authlog");

// 表的字段根据配置文件中 添加实名所需的身份信息记录，（验证码无需记录）
/*
three_auth_user_authlog表
字段：
id           =  主键ID   
user_id      =  客户ID     
create_time  =  认证时间  时间戳
update_time  =  更新时间  时间戳
app_id       =  APPID

-----上面的字段是固定的 每个实名记录表都要有

-----下面的字段是根据配置文件而定的
name      =  姓名         (该字段需和配置文件中的对应)
card_num  =  身份证号码   (该字段需和配置文件中的对应)
tel       =  手机号       (该字段需和配置文件中的对应)

插入表记录 $plugin->ide->mysql->add_db("null,'user_id','create_time','update_time','app_id','name','card_num','tel'","three_auth_user_authlog");
*/

//  每个实名应用都应当创建属于自己的实名记录信息表

if($plugin->ide->php->session("user_id")==""){
	exit("当前客户未登录");
}
if(!$plugin->ide->php->session("user_id")){
	exit("当前客户未登录");
}
$auth_money = $api_config['remark']['money']; // 实名价格
$user_datas = $plugin->ide->mysql->get_db("user_id='".$plugin->ide->php->session("user_id")."' and app_id='".$plugin->ide->lzsys_system->app_id()."'","user");

if(!$user_datas){
	exit("当前客户异常");
}

if($user_datas['balance']<$auth_money){
	exit("实名认证需要花费 ".$auth_money."元, 你的余额不足 请先 <a href='/index.php/user/pay' style='color:blue'>充值</a>");
}


/*
*   检查验证码是否超时 (自定义方法 无规律 开发者也可以自定义)
*/ 
function three_auth_vcode_time($plugin){
	if($plugin->ide->php->session("vcode_time")<>""){
		$vcode_time = $plugin->ide->php->session("vcode_time");
		$now_time = time();
		$times = $now_time - $vcode_time;
		if($times>600){
			exit("验证码已过期");
		}
		
	}
}
/*
*   生成短信验证码并且发送 (自定义方法 无规律 开发者也可以自定义)
*/ 
function three_auth_auth_code($plugin,$user,$type){
	$user['code']=$plugin->ide->lzsys_system->number(4);
	$user['code_time']="10分钟";
	$plugin->ide->php->session("vcode",$user['code']);//将验证码储存起来  验证时需要用到
	$plugin->ide->php->session("mobile",$user['mobile']);//将手机号储存起来  验证时需要用到
	
	return $plugin->ide->lzsys_system->run_sms($plugin->ide(), $user, $type);
}
/*
*   检查发送条件是否满足 (自定义方法 无规律 开发者也可以自定义)
*/ 
function three_auth_get_time($plugin){
	if($plugin->ide->php->session("vcode_time")<>""){
		$vcode_time = $plugin->ide->php->session("vcode_time");
		$now_time = time();
		$times = $now_time - $vcode_time;
		if($times<60){
			exit("你发送过于频繁，请60秒后再试");
			// 如果你是开发者 可以再次进行IP限制 手机号限制 浏览器限制等
			// 也可以在短信应用中进行限制 总而言之 方法很多。
		}
	}
}
/*
** get_sms_code 收到发送短信验证码请求   固定方法
*/
if ($get['act'] == "get_sms_code") {
	if ($post['tel'] == "") {
        exit("请输入手机号");
    }
	if($post['sms_type']==""){
		$post['sms_type'] = "auth_code";
	}
	three_auth_get_time($plugin);
	$user['mobile'] = $post['tel'];//获得接收验证码的手机号
	
	$data = three_auth_auth_code($plugin,$user,$post['sms_type']);
	$data = $plugin->ide->lzsys_system->_array($data);
	if($data['status']==true){
		$plugin->ide->php->session("vcode_time",time());  //记录验证码发送时间
		exit("True"); //成功返回True
	}
	exit($data['msg']);// 返回失败信息
}

function qcloud_three_auth($secretId,$secretKey,$idCard,$mobile,$realName){

$source = 'market';

// 签名
$datetime = gmdate('D, d M Y H:i:s T');
$signStr = sprintf("x-date: %s\nx-source: %s", $datetime, $source);
$sign = base64_encode(hash_hmac('sha1', $signStr, $secretKey, true));
$auth = sprintf('hmac id="%s", algorithm="hmac-sha1", headers="x-date x-source", signature="%s"', $secretId, $sign);

// 请求方法
$method = 'GET';
// 请求头
$headers = array(
    'X-Source' => $source,
    'X-Date' => $datetime,
    'Authorization' => $auth,
    
);
// 查询参数
$queryParams = array (
    'idCard' => $idCard,
    'mobile' => $mobile,
    'realName' => $realName,
);
// body参数（POST方法下）
$bodyParams = array (

);
// url参数拼接
$url = 'https://service-91ii7z5b-1300755093.ap-beijing.apigateway.myqcloud.com/release/efficient/cellphone';
if (count($queryParams) > 0) {
    $url .= '?' . http_build_query($queryParams);
}

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_TIMEOUT, 60);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);
curl_setopt($ch, CURLOPT_HTTPHEADER, array_map(function ($v, $k) {
    return $k . ': ' . $v;
}, array_values($headers), array_keys($headers)));
if (in_array($method, array('POST', 'PUT', 'PATCH'), true)) {
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($bodyParams));
}

$data = curl_exec($ch);
if (curl_errno($ch)) {
    return "Error: " . curl_error($ch);
} else {
    return json_decode($data,true);
}
curl_close($ch);
	
}


/*
------实名认证开始
*/
if($get['act']=="auth_api"){
	if($post['name']==""){
		exit("请输入姓名");
	}
	if($post['card_num']==""){
		exit("请输入身份证");
	}
	if($post['tel']==""){
		exit("请输入手机号");
	}
	if($post['vcode']==""){
		exit("请输入手机验证码");
	}
    $post = $plugin->ide->php->post();
    foreach($post as $k => $v) {
        if ($v == "") {
            $post[$k] = '0';
        } 
    }
    $vcode = $post['vcode'];	
    $tel = $post['tel'];	
    $card_num = $post['card_num'];	
    $name = $post['name'];
    $smscode = $plugin->ide->php->session("vcode");
    $mobile_tel = $plugin->ide->php->session("mobile");
	if ($mobile_tel <> $tel) {
		exit("验证码与手机号不匹配");
	}
	if ($vcode <> $smscode) {
		exit("验证码错误");
	}
	three_auth_vcode_time($plugin);
	// 进行实名认证操作

	$account = $api_config['remark']['account'];
	$secret = $api_config['remark']['secret'];
	$api_id = $api_config['api_id'];
	
	$auth_data = qcloud_three_auth($account,$secret,$card_num,$tel,$name);
	//$auth_data = $plugin->ide->lzsys_system->_array($auth_data1);
	//$auth_data = json_decode($auth_data1,true);
	if($auth_data['result']['VerificationResult']=="1"){
		// 认证成功 执行数据修改 如 扣除客户余额， 写财务日志，修改实名状态等
		
		// 执行修改实名状态
		$plugin->ide->mysql->up_db("auth='1',auth_api='$api_id',name='$name'","user","user_id='".$plugin->ide->php->session("user_id")."' and app_id='".$plugin->ide->lzsys_system->app_id()."'");
		
		// 执行客户余额扣除
		$plugin->ide->mysql->up_db("balance=balance-$auth_money","user","user_id='".$plugin->ide->php->session("user_id")."' and app_id='".$plugin->ide->lzsys_system->app_id()."'");
		
            // 执行写财务记录
            $pay_name = $api_config['name']; //渠道名称
			$get_orders = $plugin->ide->lzsys_system->get_orders();
			$stop_money = $user_datas[balance] - $auth_money;
            $sql_querys = "null,'$get_orders','$user_datas[user_id]','$user_datas[balance]','$auth_money','$stop_money','2','".time()."','".time()."','1','$pay_name','" . $plugin->ide->lzsys_system->app_id() . "'";
            $plugin->ide->mysql->add_db($sql_querys, "shop_finance"); 		
		
		// 写实名信息记录日志
		$app_id = $plugin->ide->lzsys_system->app_id();
		$update_time = time();
		$create_time = time();
		$user_id = $plugin->ide->php->session("user_id");
		
		$auth_log = $plugin->ide->mysql->get_db("user_id='$user_id' and app_id='$app_id'","three_auth_user_authlog");
		
		if($auth_log){
			// 已经存在记录 执行更新
			$plugin->ide->mysql->up_db("name='$name',tel='$tel',card_num='$card_num',update_time='$update_time'","three_auth_user_authlog","user_id='$user_id' and app_id='$app_id'");
		}else{
			// 不存在记录 执行写入
			$plugin->ide->mysql->add_db("null,'$user_id','$create_time','$update_time','$app_id','$name','$card_num','$tel'","three_auth_user_authlog");
		
		}
		
		// 执行短信通知
		$plugin->ide->lzsys_system->run_sms($plugin->ide(), $user_datas, "auth_yes");
		
		// 执行邮件通知
		$plugin->ide->lzsys_system->run_email($plugin->ide(), $user_datas, "auth_yes");
		exit("True");
	}
	exit(" 错误代码：".$auth_data['result']['VerificationResult']."<br>代码解说：-1 表示信息不匹配，0 表示运营商无记录");
	
}
// 实名认证结束
exit("没有找到要执行的任务");

// $plugin->ide->views->assign("imgs", $ticket_img, true);
